﻿local L = AceLibrary("AceLocale-2.2"):new("Altoholic")
local BI = LibStub("LibBabble-Inventory-3.0"):GetLookupTable()
local BZ = LibStub("LibBabble-Zone-3.0"):GetLookupTable()
local BF = LibStub("LibBabble-Faction-3.0"):GetLookupTable()
local WHITE		= "|cFFFFFFFF"
local GREEN		= "|cFF00FF00"
local YELLOW	= "|cFFFFFF00"

if GetLocale() ~= "zhCN" then return end

-- 以下为声望值、等级、技能等的建议
Altoholic.Suggestions = {
	[L["Riding"]] = {
		{ 75, "初级骑术(40级): |cFFFFFFFF90g\n|cFFFFD700主城附近的的普通坐骑：|cFFFFFFFF10g" },
		{ 150, "中级骑术(60级): |cFFFFFFFF600g\n|cFFFFD700主城附近的史诗级坐骑：|cFFFFFFFF100g" }
	},
	
	-- 来源 : http://forums.worldofwarcraft.com/thread.html?topicId=102789457&sid=1（英文）
	-- ** 主专业技能 **
	[BI["Tailoring"]] = {
		{ 50, "1~50: 亚麻布卷\n(2×亚麻布)×80" },
		{ 70, "51~70: 亚麻包\n(3×亚麻布卷|3×粗线)×20" },
		{ 75, "71~75: 强化亚麻斗篷\n(2×亚麻布卷|3×粗线)×5" },
		{ 105, "76~105: 毛布卷\n(3×毛料)×60" },
		{ 110, "106~110: 灰色毛纺衬衣\n(2×毛布卷|1×细线|1×灰色染料)×5"},
		{ 125, "111~125: 双线毛纺护肩\n(3×毛布卷|2×细线)×15" },
		{ 145, "126~145: 丝绸卷\n(4×丝绸)×190" },
		{ 160, "146~160: 碧蓝丝质头巾\n(2×丝绸卷|2×蓝色染料|1×细线)×15" },
		{ 170, "161~170: 丝质头带\n(3×丝绸卷|2×细线)×10" },
		{ 175, "171~175: 体面的白衬衣\n(3×丝绸卷|2×漂白液|1×细线)×5" },
		{ 185, "176~185: 魔纹布卷\n(5×魔纹布)×100" },
		{ 205, "186~205: 深红丝质外衣\n(4×丝绸卷|2×红色染料|2×细线)×15" },
		{ 215, "206~215: 深红丝质马裤(4×丝绸卷|2×红色染料|2×丝线)×15" },
		{ 220, "216~220: 黑色魔纹短裤\n黑色魔纹外衣\n(2×魔纹布卷|3×丝线)×5" },
		{ 230, "221~230: 黑色魔纹手套\n(2×魔纹布卷|2×粗丝线)×10" },
		{ 250, "231~250: 黑色魔纹头带\n黑色魔纹护肩\n(3×魔纹布卷|2×粗丝线)×20" },
		{ 260, "251~260: 符文布卷\n(5×符文布)×180" },
		{ 275, "261~275: 符文布腰带\n(3×符文布卷|1×符文线)×15" },
		{ 280, "276~280: 符文布背包\n(5×符文布卷|2×硬甲皮|1×符文线)×5" },
		{ 300, "281~300: 符文布手套\n(4×符文布卷|4×硬甲皮|1×符文线)×20" }
	},
	[BI["Leatherworking"]] = {
		{ 35, "1~35: 轻型护甲片\n(1×轻皮)×35" },
		{ 55, "36~55: 熟化轻毛皮\n(1×轻毛皮|1×盐)×20" },
		{ 80, "56~80: 雕花皮靴\n(8×轻皮|5×粗线)×15" },
		{ 85, "81~85: 优质皮带\n(6×轻皮|2×粗线)×5" },
		{ 90, "86~90: 优质皮外套\n(3×熟化轻毛皮|6×轻皮|4×粗线)×5" },
		{ 100, "91~100: 优质皮带\n(6×轻皮|2×粗线)×10" },
		{ 120, "101~120: 熟化中毛皮\n(1×中毛皮|1×盐)×20" },
		{ 125, "121~125: 优质皮带\n(6×轻皮|2×粗线)×5" },
		{ 150, "126~150: 黑皮腰带\n(1×优质皮带|1×熟化中毛皮|2×细线|1×灰色染料)×25" },
		{ 160, "151~160: 熟化重毛皮\n(1×重毛皮|3×盐)×10" },
		{ 170, "161~170: 重型护甲片\n(5×重皮|1×细线)×10" },
		{ 180, "171~180: 暗色皮护腿\n(10×重皮|1×黑色染料|2×细线)×10\n守护短裤\n(12×重皮|2×丝绸卷|2×细线)×10" },
		{ 195, "181~195: 野人护肩\n(8×重皮|1×熟化重毛皮|2×细线)×15" },
		{ 205, "196~205: 暗色护腕\n(16×重皮|1×黑色染料|2×丝线)×10" },
		{ 220, "206~220: 厚重护甲片\n(5×厚皮|1×丝线)×15" },
		{ 225, "221~225: 夜色头带\n(5×厚皮|2×丝线)×5" },
		{ 250, "226~250: 根据你的专精可以为：\n    元素制皮:\n夜色头带\n(5×厚皮|2×丝线)×25\n夜色外套\n(7×厚皮|2×丝线)×25\n夜色短裤(14×厚皮|4×丝线)×20\n    龙鳞制皮:\n硬化蝎壳胸甲(12×厚皮|12×蝎壳|4×丝线)×25\n硬化蝎壳手套(6×厚皮|8×蝎壳|2×丝线)×25\n部族制皮:    \n龟壳头盔(14×厚皮|24×龟壳|1×粗丝线)×20\n龟壳护腿(14×厚皮|28×龟壳|1×粗丝线)×15\n龟壳胸甲(6×厚皮|12×龟壳|1×粗丝线)×25\n龟壳手套(6×厚皮|8×龟壳|1×粗丝线)×25\n龟壳护腕(8×厚皮|12×龟壳|1×粗丝线)×25\n" },
		{ 260, "251~260: 夜色长靴\n(16×厚皮|2×粗丝线)×10" },
		{ 270, "261~270: 邪恶皮甲护手\n(8×硬甲皮|1×黑色染料|1×符文线)×10" },
		{ 285, "271~285: 邪恶皮甲护腕\n(8×硬甲皮|1×黑色染料|1×符文线)×10" },
		{ 300, "286~300: 邪恶皮甲头环\n(12×硬甲皮|1×黑色染料|1×符文线)×15" }
	},
	[BI["Engineering"]] = {
		{ 40, "1~40: 劣质火药\n(1×劣质的石头)×40" },
		{ 50, "41~50: 一把螺栓\n(1×铜锭)×10" },
		{ 51, "51: 扳手\n(6×铜锭)×1" },
		{ 65, "52~65: 铜管\n(2×铜锭|1×弱效助熔剂)×14" },
		{ 75, "66~75: 劣质火枪\n(1×铜管|1×一把螺栓|1×木柴)×10" },
		{ 95, "76~95: 粗制火药粉\n(1×粗糙的石头)×20" },
		{ 105, "96~105: 银触媒\n(1×银锭)×10" },
		{ 120, "106~120: 青铜管\n(2×青铜锭|1×弱效助熔剂)×15" },
		{ 125, "121~125: 小型青铜炸弹\n(4×粗制火药粉|2×青铜锭|1×银触媒|1×毛料)×5" },
		{ 145, "126~145: 烈性火药\n(1×沉重的石头)×20" },
		{ 150, "146~150: 重磅青铜炸弹\n(2×烈性火药|3×青铜锭|1×银触媒)×5" },
		{ 175, "151~175: 蓝色焰火|红色焰火|绿色焰火\n(1×烈性火药|1×重皮)×25" },
		{ 176, "176: 侏儒微调器\n(4×钢锭)×1" },
		{ 190, "177~190: 实心炸药\n(2×坚固的石头)×14" },
		{ 195, "191~195: 重磅铁制炸弹\n(3×烈性火药|3×铁锭|1×银触媒)×5" },
		{ 205, "196~205: 秘银管\n(3×秘银锭)×10" },
		{ 210, "206~210: 不牢固的扳机\n(1×秘银锭|1×魔纹布|1×实心炸药)×5" },
		{ 225, "211~225: 高速秘银弹头\n(1×秘银锭|1×实心炸药)×15" },
		{ 235, "226~235: 秘银外壳\n(3×秘银锭)×10" },
		{ 245, "236~245: 高爆炸弹\n(2×秘银外壳|1×不牢固的扳机|2×实心炸药)×10" },
		{ 250, "246~250: 秘银螺旋弹\n(2×秘银锭|2×实心炸药)×5" },
		{ 260, "251~260: 致密炸药粉\n(2×厚重的石头)×10" },
		{ 290, "261~290: 瑟银零件\n(3×瑟银锭|1×符文布)×30" },
		{ 300, "291~300: 瑟银管\n(3×瑟银锭)×10\n瑟银弹\n(2×瑟银锭|1×致密炸药粉)×10" }
	},
	[BI["Enchanting"]] = {
		{ 2, "1~2: 符文铜棒\n(1×铜棒|1×奇异之尘|1×次级魔法精华)×1" },
		{ 75, "3~75: 附魔护腕 - 初级生命\n(1×奇异之尘)×73" },
		{ 85, "76~85: 附魔护腕 - 初级偏斜\n(1×次级魔法精华|1×奇异之尘)×20" },
		{ 100, "86~100: 附魔护腕 - 初级耐力\n(3×奇异之尘)×15" },
		{ 101, "101: 符文银棒\n(1×银棒|6×奇异之尘|3×强效魔法精华|1×符文铜棒)×1" },
		{ 105, "102~105: 附魔护腕 - 初级耐力\n(3×奇异之尘)×4" },
		{ 120, "106~120: 强效魔法杖\n(1×普通木柴|1×强效魔法精华)×15" },
		{ 130, "121~130: 附魔盾牌 - 初级耐力\n(1×次级星界精华|2×奇异之尘)×10" },
		{ 150, "131~150: 附魔护腕 - 次级耐力\n(2×灵魂之尘)×20" },
		{ 151, "151: 符文金棒\n(1×金棒|1×彩色珍珠|2×强效星界精华|2×灵魂之尘|1×符文银棒)×1" },
		{ 160, "152~160: 附魔护腕 - 次级耐力\n(2×灵魂之尘)×9" },
		{ 165, "161~165: 附魔盾牌 - 次级耐力\n(1×次级秘法精华|1×灵魂之尘)×5" },
		{ 180, "166~180: 附魔护腕 - 精神\n(1×次级秘法精华)×15" },
		{ 200, "181~200: 附魔护腕 - 力量\n(1×幻象之尘)×20" },
		{ 201, "201: 符文真银棒\n(1×真银棒|1×黑珍珠|2×强效秘法精华|2×幻象之尘|1×符文金棒)×1" },
		{ 205, "202~205: 附魔护腕 - 力量\n(1×幻象之尘)×4" },
		{ 225, "206~225: 附魔披风 - 强效防御\n(3×幻象之尘)×20" },
		{ 235, "226~235: 附魔手套 - 敏捷\n(1×次级虚空精华|1×幻象之尘)×10" },
		{ 245, "236~245: 附魔胸甲 - 超强生命\n(6×幻象之尘)×10" },
		{ 250, "246~250: 附魔护腕 - 强效力量\n(2×梦境之尘|1×强效虚空精华)×5" },
		{ 270, "251~270: 次级法力之油\n(3×梦境之尘|2×紫莲花|1×水晶瓶)×20\n配方购于：\n卡妮亚:希利苏斯<51,39>" },
		{ 290, "271~290: 附魔盾牌 - 强效耐力\n(10×梦境之尘)×20\n附魔靴子 - 强效耐力\n(10×梦境之尘)×20" },
		{ 291, "291: 符文奥金棒\n(1×奥金棒|1×金珍珠|10×幻影之尘|4×强效不灭精华|1×符文真银棒|2×大块魔光碎片)×1" },
		{ 300, "292~300: 附魔披风 - 超强防御\n(8×幻影之尘)×9" }
	},
	[BI["Blacksmithing"]] = {	
		{ 25, "1~25: 劣质磨刀石\n(1×劣质的石头)×25" },
		{ 45, "26~45: 劣质砂轮\n(2×劣质的石头)×20" },
		{ 75, "46~75: 铜质链甲腰带\n(6×铜锭)×30" },
		{ 80, "76~80: 粗制砂轮\n(2×粗糙的石头)×5" },
		{ 100, "81~100: 铜质符文腰带\n(10×铜锭)×20" },
		{ 105, "101~105: 银棒\n(1×银锭|2×劣质砂轮)×5" },
		{ 125, "106~125: 劣质青铜护腿\n(6×青铜锭)×20" },
		{ 150, "126~150: 重砂轮\n(3×沉重的石头)×25" },
		{ 155, "151~155: 金棒\n(1×金锭|2×粗制砂轮)×5" },
		{ 165, "156~165: 绿铁护腿\n(8×铁锭|1×重砂轮|1×绿色染料)×10" },
		{ 185, "166~185: 绿铁护腕\n(6×铁锭|1×绿色染料)×20" },
		{ 200, "186~200: 金鳞护腕\n(5×钢锭|2×重砂轮)×15" },
		{ 210, "201~210: 坚固的砂轮\n(4×坚固的石头)×10" },
		{ 215, "211~215: 金鳞护腕\n(5×钢锭|2×重砂轮)×5" },
		{ 235, "216~235: 钢质头盔\n(14×钢锭|1×坚固的砂轮)×20\n秘银鳞片护腕(成本低)\n(8×秘银锭)×20\n配方购于：\n哈尔甘:辛特兰,鹰巢山<13,44>\n卡尔拉什:悲伤沼泽,斯通纳德<45,51>" },
		{ 250, "236~250: 秘银罩帽\n(10×秘银锭|6×魔纹布)×15\n秘银马刺(成本低)\n(4×秘银锭|3×坚固的砂轮)×15\n配方世界掉落" },
		{ 260, "251~260: 致密磨刀石\n(1×厚重的石头)×10" },
		{ 270, "261~270: 瑟银腰带(成本低)\n(12×瑟银锭|4×红色能量水晶)×10\n瑟银护腕(成本低)\n(12×瑟银锭|4×蓝色能量水晶)×10\n以上两种配方世界掉落\n地铸护腿 (防具锻造)\n(16×秘银锭|2×大地之核)×10\n风铸护腿(防具锻造)\n((16×秘银锭|2×风之气息))×10\n轻型地铸利刃(宗师级铸剑)\n(12×秘银锭|4×大地之核)×10\n轻型灰烬铸锤(宗师级铸锤)\n(12×秘银锭|4×火焰之心)×10\n轻型天铸战斧(宗师级铸斧)\n(12×秘银锭|4×风之气息)×10" },
		{ 295, "271~295: 君王板甲护腕\n(12×瑟银锭)×25\n配方任务取得" },
		{ 300, "296~300: 君王板甲战靴\n(18×瑟银锭)×5\n配方任务取得" }
	},
	[BI["Alchemy"]] = {	
		{ 60, "1~60: 初级治疗药水\n(1×宁神花|1×银叶草|1×空瓶)×60" },
		{ 110, "61~110: 次级治疗药水\n(1×初级治疗药水|1×石南草)×50" },
		{ 140, "111~140: 治疗药水\n(1×跌打草|1×石南草|1×铅瓶)×30" },
		{ 155, "141~155: 次级法力药水\n(1×魔皇草|1×荆棘藻|1×空瓶)×15" },
		{ 185, "156~185: 强效治疗药水\n(1×活根草|1×皇血草|1×铅瓶)×30" },
		{ 210, "186~210: 敏捷药剂\n(1×荆棘藻|1×金棘草|1×铅瓶)×25" },
		{ 215, "211~215: 强效防御药剂\n(1×野钢花|1×金棘草|1×铅瓶)×5" },
		{ 230, "216~230: 优质治疗药水\n(1×太阳草|1×卡德加的胡须|1×水晶瓶)×15" },
		{ 250, "231~250: 侦测亡灵药剂\n(1×阿尔萨斯之泪|1×水晶瓶)×20" },
		{ 265, "251~265: 强效敏捷药剂\n(1×太阳草|1×金棘草|1×水晶瓶)×15" },
		{ 285, "266~285: 优质法力药水\n(2×太阳草|2×盲目草|1×水晶瓶)×20" },
		{ 300, "286~300: 特效治疗药水\n(2×黄金参|1×山鼠草|1×水晶瓶)×15" }
	},
	[L["Mining"]] = {
		{ 65, "1~65: 铜矿\n所有起始地区" },
		{ 125, "66~125: 锡矿|银矿|火岩矿|次级血石矿\n\n火岩矿分布于瑟根石(湿地)\n很容易升到125" },
		{ 175, "126~175: 铁矿|金矿\n凄凉之地|灰谷|荒芜之地|阿拉希高地\n奥特兰克山脉|荆棘谷|悲伤沼泽" },
		{ 250, "176~250: 秘银矿|真银矿\n诅咒之地|灼热峡谷|荒芜之地|辛特兰\n西瘟疫之地|艾萨拉|冬泉谷|费伍德森林|石爪山脉|塔纳利斯" },
		{ 300, "251~300: 瑟银矿\n安戈洛环形山|冬泉谷|诅咒之地|灼热峡谷\n燃烧平原|东瘟疫之地|西瘟疫之地" }
	},
	[L["Herbalism"]] = {
		{ 50, "1~50: 银叶草|宁神花\n所有起始地区" },
		{ 70, "51~70: 魔皇草|地根草\n贫瘠之地|西部荒野|银松森林|洛克莫丹|黑海岸" },
		{ 100, "71~100: 石南草\n银松森林|暮色森林|黑海岸|洛克莫丹|赤脊山" },
		{ 115, "101~115: 跌打草\n灰谷|石爪山脉|南贫瘠之地|洛克莫丹|赤脊山" },
		{ 125, "116~125: 野钢花\n石爪山脉|阿拉希高地|荆棘谷|南贫瘠之地|千针石林" },
		{ 160, "126~160: 皇血草\n灰谷|石爪山脉|湿地|希尔斯布莱德丘陵|悲伤沼泽" },
		{ 185, "161~185: 枯叶草\n悲伤沼泽" },
		{ 205, "186~205: 卡德加的胡须\n辛特兰|阿拉希高地|悲伤沼泽" },
		{ 230, "206~230: 火焰花\n灼热峡谷|诅咒之地|塔纳利斯" },
		{ 250, "231~250: 太阳草\n费伍德森林|菲拉斯|艾萨拉|辛特兰" },
		{ 270, "251~270: 格罗姆之血\n费伍德森林|诅咒之地|玛诺洛克集会所(凄凉之地)" },
		{ 285, "271~285: 梦叶草\n安戈洛环形山|艾萨拉" },
		{ 300, "286~300: 瘟疫花\n东瘟疫之地|西瘟疫之地|费伍德森林|\n冰盖草\n冬泉谷" }
	},
	[L["Skinning"]] = {
		{ 300, "1~300: 技能等级处以5,\n所获值对应的可剥皮怪物" }
	},
	-- 来源: http://www.almostgaming.com/wowguides/world-of-warcraft-lockpicking-guide
	[L["Lockpicking"]] = {
		{ 85, "1~85: 开锁练习\n奥瑟尔伐木场，赤脊山(联盟)\n棘齿城附近的海盗船(部落)" },
		{ 150, "86~150: 制毒任务目标怪附近的箱子\n西部荒野(联盟)|贫瘠之地(部落)" },
		{ 185, "151~185: 鱼人营地(湿地)" },
		{ 225, "186~225: 萨瑟里斯海岸(凄凉之地)\n" },
		{ 250, "226~250: 苦痛堡垒(荒芜之地)" },
		{ 275, "251~275: 熔渣之池(灼热峡谷)" },
		{ 300, "276~300: 落帆海湾(塔纳利斯)\n风暴海湾(艾萨拉)" }
	},
	
	-- ** 辅助技能 **
	[BI["First Aid"]] = {
		{ 40, "1~40: 亚麻绷带" },
		{ 80, "41~80: 厚亚麻绷带\n50的时候学急救(中级)" },
		{ 115, "81~115: 绒线绷带" },
		{ 150, "116~150: 厚绒线绷带\n125的时候去买教材<中级急救教材 - 绷带缚体>和2个配方\n配方购于：\n德尼布·沃克:阿拉希高地,激流堡<27,58>\n格鲁克卡恩:尘泥沼泽,蕨墙村<35,30>\n巴莱·洛克维:尘泥沼泽,蕨墙村<36,30>" },
		{ 180, "151~180: 丝质绷带" },
		{ 210, "181~210: 厚丝质绷带\n200的时候满35级，做任务学会急救(专家级)\n地点：塞拉摩岛(联盟)|落锤镇(部落)" },
		{ 240, "211~240: 魔纹绷带\n" },
		{ 260, "241~260: 厚魔纹绷带" },
		{ 290, "261~290: 符文布绷带" },
		{ 300, "291~300: 厚符文布绷带\n300的时候去买教材<大师级急救手册 - 私人医生>\n配方购于：\n阿蕾瑟拉:地狱火半岛,塔哈玛特神殿<26,62>\n布尔库:地狱火半岛,猎鹰岗哨<22,39>" }
	},
	[BI["Cooking"]] = {
		{ 40, "1~40: 香料面包\n(1×面粉|1×甜香料)×70" },
		{ 75, "41~75: 熏熊肉\n(1×熊肉)×30\n配方购于：\n德拉克·卷刃:洛克莫丹<35,49>\n安德鲁·希尔伯特:银松森林<43,40>" },
		{ 85, "76~85: 蟹肉蛋糕(联盟)\n(1×蟹肉, 1×甜香料)×10\n熏熊肉(部落)\n(1×熊肉)×20\n配方购于：\n德拉克·卷刃:洛克莫丹<35,49>\n安德鲁·希尔伯特:银松森林<43,40>" },
		{ 90, "86~90: 煮蟹爪(联盟)\n(1×蟹爪, 1×甜香料)×5\n配方购于：\n肯多尔·卡邦卡:暴风城<74,36>\n熏熊肉(部落)\n(1×熊肉)×10\n配方购于：\n德拉克·卷刃:洛克莫丹<35,49>\n安德鲁·希尔伯特:银松森林<43,40>" },
		{ 100, "91~100: 煮蟹爪(联盟)\n(1×蟹爪|1×甜香料)×15\n配方购于：\n肯多尔·卡邦卡:暴风城<74,36>\n掘地鼠炖肉(部落)\n(1×掘地鼠)×10\n配方任务获取：[23]掘地鼠炖肉" },
		{ 125, "101~125: 掘地鼠炖肉(部落)\n(1×掘地鼠)×30\n配方任务获取：[23]掘地鼠炖肉\n干烤狼肉串(联盟)\n(2×狼肋排|1×暴风城特产调料)×25\n配方购于：\n肯多尔·卡邦卡:暴风城<74,36>" },
		{ 130, "126~130: 烤狮排(部落)\n(1×狮肉|1×辣椒)×5\n配方购于：\n扎尔夫:贫瘠之地<52,29>\n干烤狼肉串(联盟)\n(2×狼肋排|1×暴风城特产调料)×25\n配方购于：\n肯多尔·卡邦卡:暴风城<74,36>" },
		{ 175, "131~175: 美味煎蛋卷(联盟)\n(1×迅猛龙蛋|1×辣椒)×50\n配方购于：\n肯多尔·卡邦卡:暴风城<74,36>\n烤狮排(部落)\n(1×狮肉|1×辣椒)×55\n配方购于：\n扎尔夫:贫瘠之地<52,29>" },
		{ 200, "176~200: 烤迅猛龙肉\n(1×迅猛龙肉|1×辣椒)×30\n配方购于：\n耐里斯特:荆棘谷,格罗姆高营地<32,29>\n布鲁斯下士:荆棘谷,反抗军营地<37,3>" },
		{ 225, "201~225: 蜘蛛肉肠\n(2×白蜘蛛肉)×30\n\n|cFFFFFFFF225接到烹饪大师任务: 迪尔格·奎克里弗:加基森<51,27>给予\n|cFFFFD700需要12个巨蛋|10个美味的蚌肉|20个奥特兰克冷酪" },
		{ 275, "226~275: 超级煎蛋卷\n(1×巨蛋|2×舒心草)×80\n配方购于：\n琦亚:冬泉谷,永望镇<61,37>\n西米克:冬泉谷,永望镇<61,39>\n拜尔:费伍德森林,血毒岗哨<34,53>\n玛里甘:费伍德森林,刺枝林地<62,25>\n嫩狼肉排\n(1×嫩狼肉|1×舒心草)×80\n配方购于：\n迪尔格·奎克里弗:塔纳利斯,加基森<52,28>\n特鲁克·蛮鬃:辛特兰,鹰巢山<14,42>" },
		{ 285, "276~285: 洛恩塔姆薯块\n(1×洛恩塔姆地薯|1×舒心草)×10\n掉落：普希林 厄运之槌" },
		{ 300, "286~300: 沙漠肉丸子\n(1×沙虫的肉|1×舒心草)×20\n希利苏斯任务(旅店老板)" }
	},	
	-- 来源: http://www.wowguideonline.com/fishing.html
	[BI["Fishing"]] = {
		{ 50, "1~50: 任何起始地点" },
		{ 75, "51~75:\n暴风城的河里\n奥格瑞玛的池塘里" },
		{ 150, "76~150: 希尔斯布莱德丘陵的河里" },
		{ 225, "151~225: 凄凉之地|阿拉希高地\n150的时候购买<中级钓鱼教材 - 鲈鱼与你>\n配方购于：\n老人海明威:藏宝海湾<27,77>" },
		{ 250, "226~250: 辛特兰|塔纳利斯\n\n|cFFFFFFFF225开始高级钓鱼任务\n起始于各个主城，均到纳特·帕格:尘泥沼泽<59,61>\n|cFFFFD700野人海岸蓝色叉牙鱼(荆棘谷<34,35>)\n菲拉斯草鱼(沃丹提斯河, 菲拉斯)\n萨瑟里斯虎鱼(萨瑟里斯海岸北部, 葬影村附近, 凄凉之地)\n芦苇海岸大马哈鱼(芦苇海岸, 悲伤沼泽)" },
		{ 260, "251~260: 费伍德森林" },
		{ 300, "261~300: 艾萨拉" }
	},
	
	-- 建议升级地区，来源众多，不一一列举了
	["Leveling"] = {
		{ 10, "1~10级: 所有起始地区" },
		{ 20, "11~20级: "  .. BZ["Loch Modan"] .. "\n" .. BZ["Westfall"] .. "\n" .. BZ["Darkshore"] 
						.. "\n" .. BZ["Silverpine Forest"] .. "\n" .. BZ["The Barrens"]},
		{ 25, "21~25级: " .. BZ["Wetlands"] .. "\n" .. BZ["Redridge Mountains"] .. "\n" .. BZ["Ashenvale"] 
						.. "\n" .. BZ["The Barrens"] .. "\n" .. BZ["Stonetalon Mountains"] .. "\n" .. BZ["Hillsbrad Foothills"] },
		{ 28, "26~28级: " .. BZ["Duskwood"] .. "\n" .. BZ["Wetlands"] .. "\n" .. BZ["Ashenvale"] 
						.. "\n" .. BZ["Stonetalon Mountains"] .. "\n" .. BZ["Thousand Needles"] },
		{ 31, "29~31级: " .. BZ["Duskwood"] .. "\n" .. BZ["Thousand Needles"] .. "\n" .. BZ["Ashenvale"] },
		{ 35, "32~35级: " .. BZ["Thousand Needles"] .. "\n" .. BZ["Stranglethorn Vale"] .. "\n" .. BZ["Alterac Mountains"] 
						.. "\n" .. BZ["Arathi Highlands"] .. "\n" .. BZ["Desolace"] },
		{ 40, "36~40级: " .. BZ["Stranglethorn Vale"] .. "\n" .. BZ["Desolace"] .. "\n" .. BZ["Badlands"]
						.. "\n" .. BZ["Dustwallow Marsh"] .. "\n" .. BZ["Swamp of Sorrows"] },
		{ 43, "41~43级: " .. BZ["Tanaris"] .. "\n" .. BZ["Stranglethorn Vale"] .. "\n" .. BZ["Badlands"] 
						.. "\n" .. BZ["Dustwallow Marsh"] .. "\n" .. BZ["Swamp of Sorrows"] },
		{ 45, "44~45级: " .. BZ["Tanaris"] .. "\n" .. BZ["Feralas"] .. "\n" .. BZ["The Hinterlands"] },
		{ 48, "46~48级: " .. BZ["Tanaris"] .. "\n" .. BZ["Feralas"] .. "\n" .. BZ["The Hinterlands"] .. "\n" .. BZ["Searing Gorge"] },
		{ 51, "49~51级: " .. BZ["Tanaris"] .. "\n" .. BZ["Azshara"] .. "\n" .. BZ["Blasted Lands"] 
						.. "\n" .. BZ["Searing Gorge"] .. "\n" .. BZ["Un'Goro Crater"] .. "\n" .. BZ["Felwood"] },
		{ 55, "54~55级: " .. BZ["Un'Goro Crater"] .. "\n" .. BZ["Felwood"] .. "\n" .. BZ["Burning Steppes"]
						.. "\n" .. BZ["Blasted Lands"] .. "\n" .. BZ["Western Plaguelands"] },
		{ 58, "56~58级: " .. BZ["Winterspring"] .. "\n" .. BZ["Burning Steppes"] .. "\n" .. BZ["Western Plaguelands"] 
						.. "\n" .. BZ["Eastern Plaguelands"] .. "\n" .. BZ["Silithus"] },
		{ 60, "59~60级: " .. BZ["Winterspring"] .. "\n" .. BZ["Eastern Plaguelands"] .. "\n" .. BZ["Silithus"] }
	}
}